;/*
; * All button types
; *
; * This file is part of xforms package
; * T.C. Zhao and M. Overmars   (1997)
; */

(require `forms)
; "fd/butttypes_gui.h"

;/* callbacks for form form0 */
(define (button_cb ob data)
  (if (= (fl_get_object_type ob) FL_HIDDEN_BUTTON)
      (if (= (fl_show_question "Want to Quit ?" 1) FL_TRUE)
	  (begin
	    (fl_finish)
	    (exit 0)))
      (fl_addto_browser fdui_br 
			(string-append 
			 (fl_get_object_label ob)
			 " callback called: "
			 (number->string (fl_get_button ob))))))

(define (butttypes . args)
  (fl_initialize args)
  (set! fdui_form0 (create_form_form0))
  ;/* fill-in form initialization code */
  ;
  ;/* show the first form */
  (fl_show_form fdui_form0 FL_PLACE_CENTER FL_FULLBORDER "form0")
  (fl_do_forms)
  0)

;/* Form definition file generated with fdesign. */
(define fdui_form0 '())
(define fdui_br '())

(define (create_form_form0)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  360  300))
    (set! obj (fl_add_box FL_UP_BOX 0 0 360 300 ""))
    (set! obj (fl_add_button FL_HIDDEN_BUTTON 0 0 360 300 ""))
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_button FL_INOUT_BUTTON 20 168 105 30 "InOutButton"))
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 15 105 30 "NormalButton"))
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_button FL_PUSH_BUTTON 20 53 105 30 "PushButton"))
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_button FL_TOUCH_BUTTON 20 130 105 30 "TouchButton"))
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_button FL_MENU_BUTTON 20 206 105 30 "MenuButton"))
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_button FL_RETURN_BUTTON 20 244 105 30 "ReturnButton"))
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_button FL_RADIO_BUTTON 20 91 105 30 "RadioButton"))
    (fl_set_object_lstyle obj FL_BOLD_STYLE)
    (fl_set_object_callback obj button_cb 0)
    (set! obj (fl_add_browser FL_NORMAL_BROWSER 135 15 210 260 ""))
    (set! fdui_br obj)
    (fl_set_object_callback obj button_cb 0)
    (fl_end_form)
    ;
    (fl_adjust_form_size form)
    form))

;/*---------------------------------------*/


;#include "fd/butttypes_gui.c"
(butttypes)











