;/* 
; * Showing all different charts 
; *
; *  This file is part of xforms package
; *  M. Overmars and T.C. Zhao   (1997)
; */


(require `forms)

(define form `())
(define barchart `())
(define linechart `())
(define filledchart `())
(define piechart `())
(define specialpiechart `())
(define exitbut `())
(define horbarchart `())
(define spikechart `())

(define (fill_in ob)
  (let ((c FL_BLACK))
    (set! c (+ c 1))
    (fl_add_chart_value ob 15.0 "item 1" c)
    (set! c (+ c 1))
    (fl_add_chart_value ob 5.0 "item 2" c)
    (set! c (+ c 1))
    (fl_add_chart_value ob 0.0 "item 3" c)
    (set! c (+ c 1))
    (fl_add_chart_value ob -10. "item 4" c)
    (set! c (+ c 1))
    (fl_add_chart_value ob 25.0 "item 5" c)
    (set! c (+ c 1))
    (fl_add_chart_value ob 12.0 "item 6" c)))

(define (chartall . args)
  (fl_initialize args)
  (create_form_form)
  (fill_in barchart)
  (fill_in horbarchart)
  (fill_in linechart)
  (fill_in filledchart)
  (fill_in spikechart)
  (fill_in piechart)
  (fill_in specialpiechart)
  (fl_show_form form FL_PLACE_CENTER FL_TRANSIENT "Charts")
  (fl_do_forms)
  (fl_finish) ; JL : added 
  0)

(define (create_form_form)
  (let ((obj `()))
    (set! form (fl_bgn_form FL_NO_BOX 940 360))
    (set! obj (fl_add_box FL_UP_BOX 0 0 940 360 ""))
    (set! obj (fl_add_chart FL_BAR_CHART 20 20 210 140 "BAR_CHART"))
    (set! barchart obj)
    (fl_set_object_boxtype obj FL_RSHADOW_BOX)
    (set! obj (fl_add_chart FL_LINE_CHART 250 20 210 140 "LINE_CHART"))
    (set! linechart obj)   
    (fl_set_object_boxtype obj FL_RSHADOW_BOX)
    (set! obj (fl_add_chart FL_FILLED_CHART 250 190 210 140 "FILLED_CHART"))
    (set! filledchart obj)
    (fl_set_object_boxtype obj FL_RSHADOW_BOX)
    (set! obj (fl_add_chart FL_PIE_CHART 480 190 210 140 "PIE_CHART"))
    (set! piechart obj)
    (fl_set_object_boxtype obj FL_RSHADOW_BOX)
    (set! obj (fl_add_chart FL_SPECIALPIE_CHART 710 20 210 140 
			    "SPECIALPIE_CHART"))
    (set! specialpiechart obj)
    (fl_set_object_boxtype obj FL_RSHADOW_BOX)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 750 260 140 30 "Exit"))
    (set! exitbut obj)
    (set! obj (fl_add_chart FL_HORBAR_CHART 20 190 210 140 "HORBAR_CHART"))
    (set! horbarchart obj)
    (fl_set_object_boxtype obj FL_RSHADOW_BOX)
    (set! obj (fl_add_chart FL_SPIKE_CHART 480 20 210 140 "SPIKE_CHART"))
    (set! spikechart obj)
    (fl_set_object_boxtype obj FL_RSHADOW_BOX)
    (fl_end_form)))

(chartall)
