;/************
;
; show the use of setting object colors and call-back routines.
;
;
;************/

(require 'forms)

(define form 0)
(define topbox 0)

(define (change_color obj col)
  (fl_set_object_color topbox col col))


(define (makeform)
  (let ((obj `())
	(str "")
	(l `(0 1 2 3 4 5 6 7)))
    (set! form (fl_bgn_form FL_UP_BOX 100 100)) 
    (map 
     (lambda (i)
       (map 
	(lambda (j)
	  (set! str (number->string (+ (* 8 j) i)))
	  (set! obj 
		(fl_add_button 
		 FL_RADIO_BUTTON 
		 (+ 11 (* 10 i)) (+ 15 (* 10 j)) 8 6 str))
	  (fl_set_object_color obj (+ (* 8 j) i) (+ (* 8 j) i)) 
	  (fl_set_object_lalign obj FL_ALIGN_BOTTOM) 
	  (fl_set_object_callback obj change_color 
				  (+ (* 8 j) i)))
	l)) l)
    (set! topbox (fl_add_button FL_NORMAL_BUTTON 30 5 40 8 "The Color Map"))
    (fl_set_object_lsize topbox FL_LARGE_SIZE) 
    (fl_set_object_lstyle topbox FL_BOLD_STYLE) 
    (fl_end_form)
    (fl_adjust_form_size form)))

(define (colsel1 . args)
  (fl_initialize args)
  (makeform)
  (fl_scale_form form  4.0 4.0) 
  (fl_show_form form FL_PLACE_FREE FL_TRANSIENT "colsel")
  (letrec ((loop 
	    (lambda ()
	      (if (not (equal? (fl_do_forms) topbox))
		  (loop)))))
    (loop))
  (fl_hide_form form)
  0) 

(colsel1)
