;/* This demo shows the use of a browser and fl_call_object_callback.  */

(require 'forms)

(define form 0)
(define br 0)
(define but 0)

(define (load_file ob arg)
  (if (= (fl_load_browser br (fl_show_input "Filename to load" "")) 0)
      (fl_add_browser_line br "NO SUCH FILE!"))))

(define (set_size on arg)
  (fl_set_browser_fontsize br  arg))

(define (fbrowse1 . args)
  (let ((obj `()))
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 130 100))
    (set! br (fl_add_browser FL_NORMAL_BROWSER 5 5 95 90 ""))
    (set! but (fl_add_button FL_NORMAL_BUTTON 105 5 20 8 "Exit"))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 105 75 20 8 "Load"))
    (fl_set_object_callback obj load_file 0)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 105 60 20 8 "Small"))
    (fl_set_object_callback obj set_size fl_small_size)
    (fl_call_object_callback obj)
    (fl_set_button obj 1)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 105 50 20 8 "Normal"))
    (fl_set_object_callback obj set_size fl_normal_size)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 105 40 20 8 "Large"))
    (fl_set_object_callback obj set_size fl_large_size)
    (fl_end_form)
    ;
    (fl_scale_form form  4.0  4.0)
    (fl_adjust_form_size form)
    ;
    (fl_clear_browser br)
    (fl_add_browser_line br "LOAD A FILE.")
    ;
    (fl_show_form form FL_PLACE_FREE FL_FULLBORDER "Browser")
    (letrec ((loop
	      (lambda ()
		(if (not (equal? (fl_do_forms) but))
		    (loop)))))
      (loop))
    (fl_hide_form form)
    0))

(fbrowse1)




