;/*
; * Built-in xforms clock
; * T.C. Zhao and M. Overmars
; */

(require 'forms)

(define flclock 0)

(define (exit_cb ob q)
  (fl_finish)
  (exit 0))

(define (create_form_clock)
  (let ((obj `()))
    (if (not (equal? flclock 0))
	#t
	(begin
	  (set! flclock (fl_bgn_form FL_NO_BOX 500 350))
	  (set! obj (fl_add_box FL_UP_BOX 0 0 500 350 ""))
	  ;
	  (set! obj (fl_add_clock FL_DIGITAL_CLOCK 190 20 140 30 ""))
	  (fl_set_object_boxtype obj FL_ROUNDED_BOX)
	  (fl_set_object_color obj FL_COL1 FL_BLACK)
	  (fl_set_object_lsize obj FL_MEDIUM_SIZE)
	  (fl_set_object_lstyle obj FL_BOLD_STYLE)
	  ;
	  (set! obj (fl_add_clock FL_ANALOG_CLOCK 30 70 220 200 ""))
	  (fl_set_object_boxtype obj FL_UP_BOX)
	  ;
	  (set! obj (fl_add_clock FL_ANALOG_CLOCK 260 70 220 200 ""))
	  (fl_set_object_boxtype obj FL_OVAL3D_UPBOX)
	  (set! obj (fl_add_button FL_NORMAL_BUTTON 380 300 100 30 "Exit"))
	  (fl_set_object_callback obj  exit_cb 0)
	  (fl_end_form)
	  (fl_scale_form flclock 0.7 0.7)
	  ))))


(define (fclock . args)
  (fl_initialize args)
  (create_form_clock)
  (fl_show_form flclock FL_PLACE_CENTER FL_TRANSIENT "clocks")
  (fl_do_forms)
  0)

(fclock)

