;/* This demo program uses the routines in the
;   goodies section, that help you create easy
;   forms in an even easier way.
;*/

(require `forms)

(define (timeout_remove_alert id data)
  (fl_hide_alert))

(define (goodies . args)
  (let ((choice 0)
	(str1 "")
	(s ""))
    ;
    (fl_initialize args)
    (if #f
	(fl_set_resource FLOKLabel "Go")
	)
    (if (= (fl_show_question "Do you want bold font ?" 1) 1)
	(fl_set_goodies_font FL_BOLD_STYLE FL_NORMAL_SIZE))
    ;
    (fl_show_messages ; JL : changed
     (string-append "This is a test program for the goodies of the"
		    "forms library"))
    (fl_add_timeout 5000  timeout_remove_alert 0)
    (fl_show_alert "Alert"
		   "Alert form can be used to inform"
		   "recoverable errors" 0)
    ;
    (if (= (fl_show_question "Do you want to quit?" 0) 1)
	(exit 0))
    ;
    (set! str1 (fl_show_input "Give a string:" ""))
    (fl_show_message "You typed:" "" str1)
    (set! choice (fl_show_choices "Pick a choice" 3 "One" "Two" "Three" 2))
    (cond ((= choice 1)
	   (fl_show_message "You typed: One" "" ""))
	  ((= choice 2)
	   (fl_show_message "You typed: Two" "" ""))
	  ((= choice 3)
	   (fl_show_message "You typed: Three" "" ""))
	  (else 
	   (fl_show_message "An error occured!" "" "")))
    ;
    (set! s (fl_show_input "Give another string:" str1))
    ; JL : strcpy overflow check in original ?
    (set! str1 (if (string=? s "") s "<Cancel>"))
    (fl_show_message "You typed:" "" str1)
    (fl_show_messages "Good Bye")
    ;
    (fl_finish)
    0))

(goodies)
