;/*
; * Demo showing the use of groups
; *
; * T.C. Zhao and M. Overmars
; */
;;; JL : BUG - browser object and multiline input are missing !!!
;;; JL : BUG fixed 


(require 'forms)
(require 'struct)


; JL : added
(define (bits2string bits)
  (if (null? bits)
      ""
      (string-append 
       (make-string 1 (integer->char (car bits)))
       (bits2string (cdr bits)))))

;/* XPM */
(define porsche 
  '(;/* porsche pixmap
    ;* width height ncolors chars_per_pixel */
    "64 64 4 1 " 
    "  c None 	 m None   s s_slateblue " 
    ". c yellow 	 m white  s s_yellow " 
    "r c red	 m white  s s_red " 
    "b c black 	 m black  s s_black " 
    ;/* pixels */
    "                                                                " 
    "                                                                " 
    "        bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb............................................bb        " 
    "        bb..bbbb..bbbb..bbbb..bbbb..bbbb..b..b..bbbb..bb        " 
    "        bb..b..b..b..b..b..b..b..b..b..b..b..b..b.....bb        " 
    "        bb..b..b..b..b..b..b..b.....b.....b..b..b.....bb        " 
    "        bb..bbbb..b..b..bbb...bbbb..b.....bbbb..bbbb..bb        " 
    "        bb..b.....b..b..b..b.....b..b.....b..b..b.....bb        " 
    "        bb..b.....b..b..b..b..b..b..b..b..b..b..b.....bb        " 
    "        bb..b.....bbbb..b..b..bbbb..bbbb..b..b..bbbb..bb        " 
    "        bb............................................bb        " 
    "        bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb.....................bbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb......b...b...bb.....bbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb.....b...b...b....b..bbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb....bb..bb.bbbbbbb...bbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb...bbbbbbbb......bb..bbrrrrrrrrrrrrrrrrrrrrrbb        " 
    "        bb..bbbb...............bbrrrrrrrrrrrrrrrrrrrrrbb        " 
    "        bb.bbb.................bbrrrrrrrrrrrrrrrrrrrrrbb        " 
    "        bb..........b..b.......bbrrrrrrrrrrrrrrrrrrrrrbb        " 
    "        bb.....b...b..b........bbrrrrrrrrrrrrrrrrrrrrrbb        " 
    "        bb....b...b..b..bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb....b.bbbbbbbbb..............bbbbbbbbbbbbbbbbb        " 
    "        bb...bbbb.......bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb        " 
    "        bb..bbb.........b..............bbbbbbbbbbbbbbbbb        " 
    "        bb.bbb..........b...bbb........bbbbbbbbbbbbbbbbb        " 
    "        bb.........b..b.b..bbbbb.......bbbbbbbbbbbbbbbbb        " 
    "        bb.....b..b..b..b..b.bbb.....b.brrrrrrrrrrrrrrbb        " 
    "        bb....b..b..b..bb....bbb....bb.brrrrrrrrrrrrrrbb        " 
    "        bb...bb.bbbbbbb.b....bbb....bb.brrrrrrrrrrrrrrbb        " 
    "        bb..bbbbb......bb...bbbbb...b..brrrrrrrrrrrrrrbb        " 
    "        bb.bbb..........b.bbbbbbbbbbb..brrrrrrrrrrrrrrbb        " 
    "        bb..............b.b.bbbbbbbbb..brrrrrrrrrrrrrrbb        " 
    "        bbbbbbbbbbbbbbbbb.b.b....bbbb..bbbbbbbbbbbbbbbbb        " 
    "        bbbbbbbbbbbbbbbbb...b.....b.b..b..............bb        " 
    "        bbbbbbbbbbbbbbbbb........bb.bb.b...b..b.......bb        " 
    "         bbbbbbbbbbbbbbbb........b..b..b..b..b...b...bb         " 
    "         bbbbbbbbbbbbbbbb.......b..b...b.b..b...b....bb         " 
    "         bbbbbbbbbbbbbbbbb............b.bbbbbbbbbb...bb         " 
    "          bbrrrrrrrrrrrrrrb..........bbbb........bb.bb          " 
    "          bbrrrrrrrrrrrrrrrb........bbbb............bb          " 
    "           bbrrrrrrrrrrrrrrrbbbbbbbb.......b..b....bb           " 
    "           bbrrrrrrrrrrrrrrrrrrbb.....b...b..b..b..bb           " 
    "            bbrrrrrrrrrrrrrrrrrbb....b...b..b..b..bb            " 
    "            bbrrrrrrrrrrrrrrrrrbb...bb.bbbbbbbb...bb            " 
    "             bbbbbbbbbbbbbbbbbbbb...bbbb......bb.bb             " 
    "              bbbbbbbbbbbbbbbbbbb..bbb...........b              " 
    "              bbbbbbbbbbbbbbbbbbb.bbb...........bb              " 
    "               bbbbbbbbbbbbbbbbbb..............bb               " 
    "                bbbbbbbbbbbbbbbbb...b.b.b.....bb                " 
    "                 bbbbbbbbbbbbbbbb..b.b.b..b..bb                 " 
    "                  bbrrrrrrrrrrrbb..bbbbbbb..bb                  " 
    "                   bbrrrrrrrrrrbb.bbb....b.bb                   " 
    "                    bbrrrrrrrrrbb.bb......bb                    " 
    "                     bbbrrrrrrrbb.......bbb                     " 
    "                      bbbbrrrrrbb.....bbbb                      " 
    "                        bbbbrrrbb...bbbb                        " 
    "                          bbbbrbb.bbbb                          " 
    "                            bbbbbbbb                            " 
    "                              bbbb                              " 
    "                               bb                               " 
    "                                                                "
))
  
(define nomail_width  64)
(define nomail_height 64)
(define nomail_bits
  (bits2string 
   '(
     #xff #xff #xff #xff #xff #xff #xff #xff #x01 #x00 #x00 #x00
	  #x00 #x00 #x00 #x80 #x01 #x00 #x00 #x00 #x00 #x00 #x00 #x80
	  #x01 #x00 #x00 #x00 #x00 #x00 #x00 #x80 #x01 #x00 #x00 #x80
	  #x07 #x00 #x00 #x80 #x01 #x00 #x00 #x70 #x38 #x00 #x00 #x80
	  #x01 #x00 #x00 #x0e #xc0 #x00 #x00 #x80 #x01 #x00 #xc0 #x01
	  #x00 #x01 #x00 #x80 #x01 #x00 #x38 #x00 #x00 #x02 #x00 #x80
	  #x01 #x00 #x06 #x00 #x00 #x04 #x00 #x80 #x01 #xc0 #x1f #x00
	  #x00 #x04 #x00 #x80 #x01 #x30 #x60 #x00 #x00 #x08 #x00 #x80
	  #x01 #x08 #x80 #x00 #x00 #x08 #x00 #x80 #x01 #x04 #x07 #x01
	  #x00 #x10 #x00 #x80 #x01 #x82 #x0f #x02 #x00 #x10 #x00 #x80
	  #x01 #x82 #x0f #x02 #x00 #x10 #x00 #x80 #x01 #x01 #x07 #x04
	  #x00 #x20 #x00 #x80 #x01 #x01 #x00 #x04 #x00 #x20 #x00 #x80
	  #x81 #x00 #x00 #x08 #x00 #x26 #x00 #x80 #x81 #x00 #x00 #x08
	  #x80 #x27 #x00 #x80 #x81 #x00 #x00 #x08 #xe0 #x27 #x00 #x80
	  #x81 #x22 #xa2 #x08 #xd8 #x27 #x00 #x80 #x41 #x36 #xa5 #x10
	  #xc6 #x27 #x00 #x80 #x41 #xaa #xa8 #x90 #xc1 #x27 #x00 #x80
	  #x41 #xaa #xaf #x90 #xc1 #x27 #x00 #x80 #x41 #xa2 #xa8 #x10
	  #xc0 #x27 #x00 #x80 #x41 #xa2 #xa8 #x17 #xc0 #x21 #x00 #x80
	  #x41 #x00 #x00 #x10 #x40 #x20 #x00 #x80 #x41 #x00 #x00 #x10
	  #x00 #x20 #x00 #x80 #x41 #xfe #xff #x17 #x00 #x20 #x00 #x80
	  #x41 #x00 #x00 #x10 #x00 #x30 #x00 #x80 #x41 #xfe #xff #x17
	  #x00 #x3c #x0e #x80 #x41 #x00 #x00 #x10 #x00 #x0f #x11 #x80
	  #x41 #x00 #x00 #x10 #xc0 #x1b #x11 #x80 #x41 #x00 #x00 #x10
	  #xf0 #xe4 #x10 #x80 #x41 #x00 #x00 #x10 #x3c #x84 #x08 #x80
	  #x41 #x00 #x00 #x10 #x0f #x88 #x3c #x80 #x41 #x00 #x00 #xd0
	  #x03 #xf0 #x43 #x80 #x41 #x00 #x00 #xf0 #x01 #x8c #x43 #x80
	  #xc1 #xff #xff #x3f #x01 #x82 #x24 #x80 #xc1 #xff #xff #x1f
	  #x01 #x82 #x18 #x80 #x01 #x00 #x02 #x02 #x01 #xfc #x08 #x80
	  #x01 #x00 #x02 #x02 #x01 #x20 #x09 #x80 #x01 #x00 #x02 #x02
	  #x01 #x10 #x06 #x80 #x01 #x00 #x02 #x02 #x01 #x10 #x00 #x80
	  #x01 #x00 #x02 #x02 #x01 #x08 #x00 #x80 #x01 #x00 #x02 #x02
	  #x01 #x08 #x00 #x80 #x01 #x00 #x02 #x02 #x01 #xb4 #x3f #x80
	  #x01 #x00 #x02 #x02 #x01 #x0e #x28 #x80 #x01 #x00 #x02 #x02
	  #x01 #x03 #x16 #x80 #x01 #x00 #x02 #x02 #x81 #xc0 #x11 #x80
	  #x01 #x00 #x02 #x02 #x41 #x38 #x08 #x80 #x01 #x00 #x02 #x02
	  #x21 #x04 #x04 #x80 #x01 #x00 #x02 #x02 #x11 #x03 #x02 #x80
	  #x01 #x00 #x02 #x02 #xc9 #x80 #x01 #x80 #x01 #x00 #x02 #x02
	  #x25 #x60 #x00 #x80 #x01 #x00 #x02 #x02 #x13 #x18 #x00 #x80
	  #x01 #x00 #x02 #x02 #x01 #x07 #x00 #x80 #x01 #x00 #x02 #xc2
	  #xfe #x00 #x00 #x80 #x01 #x00 #x02 #x32 #x00 #x00 #x00 #x80
	  #x01 #x00 #x02 #x0e #x00 #x00 #x00 #x80 #x01 #x00 #xfe #x03
	  #x00 #x00 #x00 #x80 #x01 #x00 #x00 #x00 #x00 #x00 #x00 #x80
	  #xff #xff #xff #xff #xff #xff #xff #xff
	  )))

(define bm1_width 16)
(define bm1_height 16)
(define bm1_bits 
  (bits2string 
   '(
     #x00 #x00 #x00 #x57 #x7c #x72 #xc4 #x52 #xc4 #x00 #x44 #x01
	  #x44 #x1f #xfc #x22 #x40 #x42 #x40 #x44 #x40 #x43 #xc0 #x40
	  #x70 #x40 #x8c #x20 #x00 #x1f #x00 #x00
	  )))



;/**** Forms and Objects ****/
(define NGROUP  4)

(define-record fdui
  (objsform
   vdata
   ldata
   cdata
   bitbutton
   pixbutton
   bit
   pix
   chart
   quit
   menu
   choice
   browser
   xyplot
   button
   group
   ))

(define fd (make-fdui '() '() '() '()
		      '() '() '() '()
		      '() '() '() '()
		      '() '() (make-vector 5 '()) (make-vector 5 '())))

;/* callbacks for form objsform */
(define (show_group ob data)
  (map (lambda (i)
	 (if (= i data)
	     (fl_show_object (vector-ref (fdui->group fd) i))
	     (fl_hide_object (vector-ref (fdui->group fd) i))))
       '(0 1 2 3 4))
;  (fl_flush)
;  (fl_update)
  )

(define (init_gui s)
  (let ((x '(0 1 2 3 4 5))
	(y '(5.5 4 4.5 3.8 4 5))
	(label '("Mon" "Tue" "Wed"  "Thur" "Fri" "Sat")))
    (fl_addto_menu (fdui->menu s) "One\tF1|Two\tF2|Three\tF3|Four\tF4")
    (fl_addto_choice (fdui->choice s) "Option1|Option2|Option3")
    ;
    (fl_set_pixmapbutton_data (fdui->pixbutton s) porsche)
    (fl_set_pixmap_data (fdui->pix s) porsche)
    (fl_set_bitmapbutton_data (fdui->bitbutton s)
			      bm1_width  bm1_height bm1_bits)
    (fl_set_bitmap_data (fdui->bit s) nomail_width  nomail_height  nomail_bits)
    ;
    (fl_set_browser_fontsize (fdui->browser s) FL_NORMAL_SIZE)
    (fl_addto_browser (fdui->browser s) "browser line 1\nbrowser line 2")
    (fl_addto_browser (fdui->browser s) "browser line 3\nbrowser line 4")
    (fl_addto_browser (fdui->browser s) "browser line 5\nbrowser line 6")
    (fl_addto_browser (fdui->browser s) "browser line 7\nbrowser line 8")
    (fl_addto_browser (fdui->browser s) "browser line 9\nbrowser line 10")
    (fl_addto_browser (fdui->browser s) "browser line 11\nbrowser line 12")
    (fl_addto_browser (fdui->browser s) "browser line 13\nbrowser line 14")
    (fl_addto_browser (fdui->browser s) "browser line 15\nbrowser line 16")
    (fl_addto_browser (fdui->browser s) "browser line 17\nbrowser line 18")
    ;
    (map (lambda (i)
	   (fl_add_chart_value (fdui->chart s)
			       (list-ref y i)
			       (list-ref label i) (+ i 1)))
	 x)
    ;
    (fl_set_xyplot_data (fdui->xyplot s) x y 6 "" "" "")
    (fl_add_xyplot_overlay (fdui->xyplot s) 1  x  y  6  FL_RED)
    (fl_add_xyplot_text (fdui->xyplot s) 2.5 5.2 "Weekly Summary"  
                       FL_ALIGN_CENTER FL_BLUE)
    (fl_add_xyplot_text (fdui->xyplot s) 3  3.85  "@-22->"  
			FL_ALIGN_TOP  FL_RED)
    ;
    (fl_set_xyplot_overlay_type (fdui->xyplot s) 1 FL_NORMAL_XYPLOT)
    (fl_set_xyplot_alphaxtics (fdui->xyplot s) "Mon|Tue|Wed|Thu|Fri|Sat"  "")
    (fl_set_xyplot_ytics (fdui->xyplot s) -1 -1)
    (fl_set_xyplot_linewidth (fdui->xyplot s) 0  3)
    ))

(define (group . args)
  (fl_set_border_width -3)
  (fl_initialize args)
  (set-fdui-objsform! fd (create_form_objsform))
  (init_gui fd)
  ; /* fill-in form initialization code */
  (fl_set_button (vector-ref (fdui->button fd) 0)  1)
  (show_group 0  0)
  ;/* show the first form */
  (fl_show_form (fdui->objsform fd) FL_PLACE_CENTER FL_FULLBORDER "objsform")
  (letrec ((loop (lambda ()
		   (if (not (equal? (fdui->quit fd) (fl_do_forms)))
		       (loop)))))
    (loop))
  (fl_finish)
  (exit 0))

;/* Form definition file generated with fdesign. */

(define (create_form_objsform)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  456  361))
    (set! obj (fl_add_box FL_FLAT_BOX 0 0 456 361 ""))
    (set! obj (fl_add_box FL_UP_BOX 0 0 455 360 ""))
    (set! obj (fl_add_box FL_UP_BOX 0 0 456 70 ""))
    (set! obj (fl_add_button FL_RADIO_BUTTON 15 20 75 30 "Static"))
    (vector-set! (fdui->button fd) 0 obj)
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_lstyle obj FL_TIMESBOLD_STYLE)
    (fl_set_object_callback obj show_group 0)
    (set! obj (fl_add_button FL_RADIO_BUTTON 90 20 75 30 "Button"))
    (vector-set! (fdui->button fd) 1 obj)
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_lstyle obj FL_TIMESBOLD_STYLE)
    (fl_set_object_callback obj show_group 1)
    (set! obj (fl_add_button FL_RADIO_BUTTON 165 20 70 30 "Valuator"))
    (vector-set! (fdui->button fd) 2 obj)
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_lstyle obj FL_TIMESBOLD_STYLE)
    (fl_set_object_callback obj show_group 2)
    (set! obj (fl_add_button FL_RADIO_BUTTON 235 20 70 30 "Input"))
    (vector-set! (fdui->button fd) 3 obj)
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_lstyle obj FL_TIMESBOLD_STYLE)
    (fl_set_object_callback obj show_group 3)
    (set! obj (fl_add_button FL_RADIO_BUTTON 305 20 70 30 "Other"))
    (vector-set! (fdui->button fd) 4 obj)
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_lstyle obj FL_TIMESBOLD_STYLE)
    (fl_set_object_callback obj show_group 4)
    (set! obj (fl_add_box FL_UP_BOX 0 70 456 291 ""))
    (set! obj (fl_add_box FL_DOWN_BOX 9 90 435 260 ""))
    ; 2
    (vector-set! (fdui->group fd) 2 (fl_bgn_group))
    (set! obj (fl_add_text FL_NORMAL_TEXT 260 140 80 30 "Text"))
    (fl_set_object_lalign obj (logior FL_ALIGN_LEFT FL_ALIGN_INSIDE))
    (set! obj (fl_add_slider FL_HOR_BROWSER_SLIDER 60 120 170 25 ""))
    (set! obj (fl_add_slider FL_HOR_FILL_SLIDER 60 160 170 30 ""))
    (fl_set_slider_value obj  0.54)
    (set! obj (fl_add_slider FL_VERT_SLIDER 390 110 30 170 ""))
    (fl_set_slider_value obj  0.48)
    (set! obj (fl_add_valslider FL_VERT_SLIDER 350 110 30 170 ""))
    (set! obj (fl_add_dial FL_FILL_DIAL 50 220 90 70 ""))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_positioner FL_NORMAL_POSITIONER 150 210 120 100 ""))
    (set! obj (fl_add_counter FL_NORMAL_COUNTER 300 300 130 30 ""))
    (fl_end_group)
    ; 1
    (vector-set! (fdui->group fd) 1 (fl_bgn_group))
    (set! obj (fl_add_bitmapbutton FL_NORMAL_BUTTON 60 250 50 40 ""))
    (set-fdui-bitbutton! fd obj)
    (set! obj (fl_add_pixmapbutton FL_NORMAL_BUTTON 85 120 80 80 ""))
    (set-fdui-pixbutton! fd obj)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 290 270 90 35 "Button"))
    (set! obj (fl_add_round3dbutton FL_PUSH_BUTTON 260 95 60 40 
				    "Round3DButton"))
    (fl_set_object_color obj  FL_COL1  FL_MAGENTA)
    (set! obj (fl_add_roundbutton FL_PUSH_BUTTON 220 140 60 40 "RoundButton"))
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 190 230 50 40 "CheckButton"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_lightbutton FL_PUSH_BUTTON 290 200 100 30 "LightButton"))
    (set! obj (fl_add_button FL_PUSH_BUTTON  120  290  100  35  "Button"))
    (fl_set_object_boxtype obj  FL_ROUNDED3D_UPBOX)
    (fl_end_group)
    ; 0
    (vector-set! (fdui->group fd) 0 (fl_bgn_group))
    (set! obj (fl_add_box FL_UP_BOX 40 120 70 70 "A Box"))
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_lstyle obj FL_TIMESBOLD_STYLE)
    (set! obj  (fl_add_bitmap FL_NORMAL_BITMAP 30 220 80 70 "bitmap"))
    (set-fdui-bit! fd obj)
    (set! obj (fl_add_clock FL_ANALOG_CLOCK 330 240 90 80 ""))
    (set! obj (fl_add_frame FL_ENGRAVED_FRAME 130 120 80 70 "A Frame"))
    (fl_set_object_lsize obj FL_NORMAL_SIZE)
    (fl_set_object_lstyle obj FL_TIMESBOLD_STYLE)
    (set! obj (fl_add_pixmap FL_NORMAL_PIXMAP 340 110 90 70 "pixmap"))
    (set-fdui-pix! fd obj)
    (set! obj (fl_add_chart FL_PIE_CHART 160 210 130 110 "chart"))
    (set-fdui-chart! fd obj)
    (set! obj (fl_add_text FL_NORMAL_TEXT 240 130 100 30 
			   "Text stuff\nand more stuff"))
    (fl_set_object_lalign obj (logior FL_ALIGN_CENTER FL_ALIGN_INSIDE))
    (fl_end_group)
    ; 3
    (vector-set! (fdui->group fd) 3 (fl_bgn_group))
    (set! obj (fl_add_input FL_NORMAL_INPUT 140 120 150 30 "Input"))
    (set! obj (fl_add_input FL_MULTILINE_INPUT 60 170 320 130 ""))
    (fl_end_group)
    ;
    (set! obj (fl_add_button FL_NORMAL_BUTTON 385 20 60 30 "Quit"))
    (set-fdui-quit! fd obj)
    ; 4
    (vector-set! (fdui->group fd) 4 (fl_bgn_group))
    (set! obj (fl_add_menu FL_PULLDOWN_MENU 190 110 40 19 "Menu"))
    (set-fdui-menu! fd obj)
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (set! obj (fl_add_choice FL_NORMAL_CHOICE 290 110 120 30 ""))
    (set-fdui-choice! fd obj)
    (set! obj (fl_add_browser FL_NORMAL_BROWSER 30 140 140 150 ""))
    (set-fdui-browser! fd obj)
    (set! obj (fl_add_xyplot FL_IMPULSE_XYPLOT 190 150 240 180 ""))
    (set-fdui-xyplot! fd obj)
    (fl_set_object_lsize obj FL_DEFAULT_SIZE)
    (fl_end_group)
    ;
    (fl_end_form)
    form))

;/*---------------------------------------*/

(group)



