;/*
; * Test iconification
; *
; * T.C. Zhao and M. Overmars
; */
(require `forms)
(require `logical)

;/* XPM */
(define crab '(
	       
	       ;/* crab pixmap
	       ;* width height ncolors chars_per_pixel */
	       "28 28 6 2 "
	       ".  c None 	 m white 	 s s_SkyBlue "
	       "x  c orange 	 m black 	 s s_orange "
	       "*  c #ff72c2 	 m black 	 s s_#ff72c2 "
	       "+  c SteelBlue 	 m white 	 s s_SteelBlue "
	       "G  c black 	 m black 	 s s_black "
	       "a  c LightGrey 	 m white 	 s s_LightGrey "
	       ;/* pixels */
	       ". . . . . . * * * * . . . . . . . . . * * * * . . . . . "
	       ". . . . + * x x * . . . . . . . . . . + * x x * . . . . "
	       ". . . + * x x * . . . . . . . . . . . . + * x x * . . . "
	       ". . + * x * . . . * . . . . . . . . . * . . + * x * . . "
	       ". . + * x * . . + * . . . . . . . . + * . . + * x * . . "
	       ". . + * x * . + * * . . . . . . . . + * * . + * x * . . "
	       ". . + * x * + * * . . . . . . . . . . + * * + * x * . . "
	       ". . + * x * * * . . . . . . . . . . . . + * * x x * . . "
	       ". . . + * x * . . + * . . . . . . + * . . + * x * . . . "
	       ". . . + * x . . + * . + * * . * * . + * . . + x * . . . "
	       ". . . . + x . . + * . + * * . * * . + * . . + x . . . . "
	       ". . . . + x . . . + * + * * * * * + * . . . + x . . . . "
	       ". . . . + * x . . + * * * * * * * * * . . + x * . . . . "
	       ". . . . . + * x * * * * x x x x x * * * * x * . . . . . "
	       ". . . . + + + * * x x x x x x x x x x x x * . . . . . . "
	       ". . + + * x x x x x x x x x x x x x x x x x x * x . . . "
	       ". + * x x a + * * x x x x x x x x x x x * * a G * x * . "
	       "+ * x . . . + * * x x x x x x x x x x x * * G . . . x * "
	       ". . . . . . + * * x x x x x x x x x x x * * . . . . . . "
	       ". . . . . + * * x x x x x x x x x x x x x * * . . . . . "
	       ". . . + * x x x * x x x x x x x x x x x * x x x * . . . "
	       ". . + * x a a + * * x x x x x x x x x * * a a a x * . . "
	       ". + * x G G G + * * x x x x x x x x x * * a G G G x * . "
	       ". + * G . . . + * x * x x x x x x x * x * a G . . . * . "
	       ". . . . . . + * x a * * * x x x * * * a x * G . . . . . "
	       ". . . . . + * x a G a a * * * * * a a G a x * G . . . . "
	       ". . . . . + x a G . G G a a a a a G G . G G x a G . . . "
	       ". . . . . + x a G . . . G G G G G . . . . . x a G . . . "
	       ))


(define form `())


(define (create_form_form0)
  (let ((obj `()))
    (if (not (equal? form `()))
	form
	(begin
	  (set! form (fl_bgn_form FL_NO_BOX 151 111))
	  (set! obj (fl_add_pixmapbutton FL_NORMAL_BUTTON 0 0 151 111 
					 "Iconify Me\nvia Window Manager"))
	  (fl_set_object_lalign obj  (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
	  (fl_set_object_lstyle obj FL_BOLD_STYLE)
	  (fl_set_pixmapbutton_data obj  crab)
	  (fl_end_form)
	  form))))

(define (iconify . args)
  (fl_initialize args)
  (let* ((form0 (create_form_form0))
	(pix (fl_read_pixmapfile (fl_root) "crab.xpm" 0))
	(p (car pix))
	(mask (cadddr pix))
	(w (cadr pix))
	(h (caddr pix)))
    (fl_set_form_icon form0  p  mask)
    (fl_show_form form0 FL_PLACE_CENTER FL_FULLBORDER  "IconTest")
    (fl_do_forms)
    0))

(iconify)


