;/*
; * Inverted slider
; *
; * T.C. Zhao and M. Overmars
; */

(require 'forms)

(define fd_inv '())
(define fd_sl0 '())
(define fd_sl1 '())
(define fd_sl2 '())
(define fd_done '())

(define (invert_it ob data)
  (if (= (fl_get_button ob) FL_TRUE)
      (begin
	(fl_set_slider_bounds fd_sl0 1.0 0.0)
	(fl_set_slider_bounds fd_sl1 1.0 0.0)
	(fl_set_slider_bounds fd_sl2 1.0 0.0))
      (begin
	(fl_set_slider_bounds fd_sl0 0.0 1.0)
	(fl_set_slider_bounds fd_sl1 0.0 1.0)
	(fl_set_slider_bounds fd_sl2 0.0 1.0))))

(define (invslider . args)
  (fl_initialize args)
  (set! fd_inv (create_form_inv))
  ;/* fill-in form initialization code */
  (fl_show_form fd_inv FL_PLACE_CENTER FL_TRANSIENT "inv")
  (letrec ((loop (lambda ()
		   (if (not (equal? (fl_do_forms) fd_done))
		       (loop)))))
    (loop))
  (fl_finish)
  (exit 0))

;/* Form definition file generated with fdesign. */

(define (create_form_inv)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX 245 280))
    (set! obj (fl_add_box FL_UP_BOX 0 0 245 280 ""))
    (set! obj (fl_add_valslider FL_VERT_SLIDER 20 30 35 230 ""))
    (set! fd_sl0 obj)
    (set! obj (fl_add_valslider FL_VERT_FILL_SLIDER 65 30 35 230 ""))
    (set! fd_sl1 obj)
    (set! obj (fl_add_valslider FL_VERT_NICE_SLIDER 115 30 35 230 ""))
    (set! fd_sl2 obj)
    (fl_set_object_boxtype obj FL_FLAT_BOX)
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (set! obj (fl_add_button FL_RETURN_BUTTON 160 235 75 30 "Exit"))
    (set! fd_done obj)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 165 30 75 35 "Invert"))
    (fl_set_object_callback obj invert_it 0)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(invslider)

