;/* Demo showing activating and deactivating objects
;*/

(require `forms)

(define form `())

(define button1 `()) 
(define button2 `()) 
(define button3 `()) 
(define button4 `()) 
(define group `()) 
(define firstbut `()) 

(define (exit_cb obj arg)
  (fl_finish)
  (exit 0)) 

(define (setit obj val)
  (if (= val 1)
      (begin
	(fl_set_object_lcol obj FL_BLACK) 
	(fl_activate_object obj))
      (begin
	(fl_set_object_lcol obj FL_INACTIVE)
	(fl_deactivate_object obj))))

(define (doit b1 b2 b3 b4)
  (setit button1 b1)
  (setit button2 b2)
  (setit button3 b3)
  (setit button4 b4))


(define (set_active obj arg)
  (cond ((= arg 0)
	 (doit 1 1 1 1))
	((= arg 1)
	 (doit 0 0 0 0))
	((= arg 2)
	 (doit 0 1 0 1))
	((= arg 3)
	 (doit 1 0 1 0))
	(else 0)))
   
(define (create_form)
  (let ((obj `()))
    (set! form (fl_bgn_form FL_NO_BOX 420 230))
    (set! obj (fl_add_box FL_UP_BOX 0 0 420 230 ""))
    (fl_set_object_color obj FL_SLATEBLUE FL_COL1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 170 150 40 "Button 1"))
    (set! button1 obj)     
    (fl_set_object_lsize obj FL_LARGE_SIZE)
    (fl_set_button_shortcut obj  "1"  1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 120 150 40 "Button 2"))
    (set! button2 obj)     
    (fl_set_object_lsize obj FL_LARGE_SIZE)
    (fl_set_button_shortcut obj  "2"  1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 70 150 40 "Button 3"))
    (set! button3 obj)     
    (fl_set_object_lsize obj FL_LARGE_SIZE)
    (fl_set_button_shortcut obj  "3"  1)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 20 150 40 "Button 4"))
    (set! button4 obj)     
    (fl_set_button_shortcut obj  "4"  1)
    (fl_set_object_lsize obj FL_LARGE_SIZE)
    (set! group (fl_bgn_group))
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 260 180 140 30 "All active"))
    (set! firstbut obj)     
    (fl_set_object_callback obj set_active 0)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 260 150 140 30 "Non active"))
    ; JL : none ?
    (fl_set_object_callback obj set_active 1)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 260 120 140 30 
				  "Even active"))
    (fl_set_object_callback obj set_active 2)
    (set! obj (fl_add_lightbutton FL_RADIO_BUTTON 260 90 140 30 "Odd active"))
    (fl_set_object_callback obj set_active 3)
    (fl_end_group)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 270 20 130 30 "Quit"))
    (fl_set_object_callback obj exit_cb 0)
    (fl_end_form)))

(define (objinactive . args)
  (fl_initialize args)
  (create_form)
  ;
  (fl_set_button firstbut 1)
  ;
  (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "")
  ;
  (letrec ((loop
	    (lambda ()
	      (fl_do_forms)
	      (loop))))
    (loop))
  ;
  0)

(objinactive)
