;/* 
; * This is a crazy demo showing the "use" of changing
; * fields in objects.
; *
; *  T.C. Zhao and M. Overmars
; */

(require `forms)

(define but '())
(define form '())
(define dx 11)
(define dy  7)

(define (move_cb ob data)
  (let* (;(but data)
	 (geom (fl_get_object_geometry but))
	 (x (car geom))
	 (y (cadr geom))
	 (w (caddr geom))
	 (h (cadddr geom))
	 (fsize (fl_get_form_size form))
	 (fw (car fsize))
	 (fh (cadr fsize)))
    (if (or (< (+ x dx) 0)
	    (>= (+ x w dx) fw))
	(set! dx (* -1 dx))
	(if (or (< (+ y dy) 0) ; JL : else (!)
		(>= (+ y h dy) fh))
	    (set! dy (* -1 dy))))
    (set! x (+ x dx))
    (set! y (+ y dy))
    (fl_set_object_position but x y)))

(define (objpos . args)
  (let (;(form `())
	;(but `())
	(obj `()))
    (fl_initialize args)
    (set! form (fl_bgn_form FL_DOWN_BOX 400 200))
    (set! but (fl_add_button FL_NORMAL_BUTTON 140 160 70 35 "Exit"))
    (set! obj (fl_add_button FL_TOUCH_BUTTON 330 150 50 30 "Move"))
    (fl_set_object_callback obj move_cb 0);but)
    (fl_end_form)
    ;
    (fl_show_form form FL_PLACE_MOUSE FL_NOBORDER "ObjPos")
    (fl_do_forms)
    (fl_hide_form form)
    0))

(objpos)

