;/* demo showing the choices when to return object. Note this program,
; * strictly speaking, is illegal in the usage of user data parameter
; * in the callback function.
; *
; *  T.C. Zhao and M. Overmars
; */
; JL : rather than allowing illegal values, I use integers
;      as a index to a list of strings


;/**** Forms and Objects ****/
(define fd_form0 '())
(define fd_obj '())
(define fd_br '())
(define fd_when '())

(define messages
  '("slider returned"
    "counter returned"
    "input1 returned"
    "input2 returned"))

;/* callbacks for form form0 */
(define (return_cb ob data)
  (fl_addto_browser fd_br (list-ref messages data)))

(define (set_when n)
  (map (lambda (o)
	 (fl_set_object_return o n))
       fd_obj))

(define (when_cb ob data)
  (let ((n (- (fl_get_choice ob) 1)))
    (if (>= n 0)
	(set_when n))))

(define (resetlog_cb ob data)
  (fl_clear_browser fd_br))

(define (objreturn . args)
  (fl_set_border_width -2)
  (fl_initialize args)
  (set! fd_form0 (create_form_form0))
  ;/* fill-in form initialization code */
  (set_when 0)
  (fl_set_object_dblbuffer fd_br 1)
  (fl_addto_choice 
   fd_when
   "RETURN_END_CHANGED|RETURN_CHANGED|RETURN_END|RETURN_ALWAYS")
  ; /* show the first form */
  (fl_show_form fd_form0 FL_PLACE_CENTER FL_FULLBORDER "form0")
  (fl_do_forms)
  (fl_finish)
  (exit 0))

(define (create_form_form0)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  321  276))
    (set! obj (fl_add_box FL_UP_BOX 0 0 321 276 ""))
    (set! obj (fl_add_valslider FL_HOR_SLIDER 12 55 138 22 ""))
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_callback obj return_cb 0)
    (fl_set_slider_return obj  FL_RETURN_CHANGED)
    (set! fd_obj (append fd_obj (list obj)))
    (set! obj (fl_add_counter FL_NORMAL_COUNTER 12 85 138 22 ""))
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_callback obj return_cb 1)
    (set! fd_obj (append fd_obj (list obj)))
    (set! obj (fl_add_input FL_NORMAL_INPUT 12 150 138 25 ""))
    (fl_set_object_callback obj return_cb 2)
    (set! fd_obj (append fd_obj (list obj)))
    (set! obj (fl_add_input FL_NORMAL_INPUT 12 187 138 25 ""))
    (fl_set_object_lalign obj (logior FL_ALIGN_LEFT FL_ALIGN_INSIDE))
    (fl_set_object_callback obj return_cb 3)
    (set! fd_obj (append fd_obj (list obj)))
    (set! obj (fl_add_browser FL_NORMAL_BROWSER 170 55 140 160 ""))
    (set! fd_br obj)
    (set! obj (fl_add_choice FL_NORMAL_CHOICE 80 12 168 27 ""))
    (set! fd_when obj)
    (fl_set_object_callback obj when_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 170 239 80 25 "Done"))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 70 239 80 25 "ResetLog"))
    (fl_set_object_callback obj resetlog_cb 0)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(objreturn)