;/* This demo shows the use of a positioner.  */

(require 'forms)

(define xval `())
(define yval `())

;/* callback routine */
(define (positioner_cb ob q)
  (let* ((astr1 (number->string (fl_get_positioner_xvalue ob)))
         (str1 (if (< (string-length astr1) 8)
                   astr1
                   (substring astr1 0 8)))
	 (astr2 (number->string (fl_get_positioner_yvalue ob)))
         (str2 (if (< (string-length astr2) 8)
                   astr2
                   (substring astr2 0 8))))
    (fl_set_object_label xval str1)
    (fl_set_object_label yval str2)))


(define (positioner . args)
  (let ((form `())
	(pos `())
	(button `()))
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 400 280))
    (set! pos (fl_add_positioner FL_NORMAL_POSITIONER 40 40 200 200 ""))
    (fl_set_positioner_xbounds pos 0 1)
    (fl_set_positioner_ybounds pos 0 1)
    (fl_set_object_callback pos positioner_cb 0)
    (set! xval (fl_add_box FL_DOWN_BOX 270 40 100 30 ""))
    (set! yval (fl_add_box FL_DOWN_BOX 270 90 100 30 ""))
    (fl_set_object_color xval FL_COL1 FL_COL1)
    (fl_set_object_color yval FL_COL1 FL_COL1)
    (set! button (fl_add_button FL_NORMAL_BUTTON 270 210 100 30 "Exit"))
    (fl_end_form)
    ;
    (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "")
    (positioner_cb pos 0)
    (fl_do_forms)
    (fl_hide_form form)
    0))

(positioner)
