;/*
; * scrollbar functionality check-out
; */
(require 'forms)


(define (hide_cb ob data)
  (if (= (fl_get_object_visible fd_hor_thin) FL_TRUE)
      (begin
        (fl_set_object_label fd_hide "Show")
        (fl_hide_object fd_hor_thin))
      (begin
        (fl_set_object_label fd_hide "Hide")
        (fl_show_object fd_hor_thin))))

(define (deactivate_cb ob data)
  (if (= (fl_get_object_active fd_hor_thin) 1)
      (begin
        (fl_set_object_label fd_deactivate "Activate")
        (fl_deactivate_object fd_hor_thin))
      (begin
	(fl_set_object_label fd_deactivate "Deactivate")
        (fl_activate_object fd_hor_thin))))
    
(define (done_cb ob data)
  (exit 0))

(define (noop_cb ob data)
  #f)


(define (scrollbar . args)
  (let ((fd_scb '()))
    (fl_set_border_width -2) 
    (fl_initialize args)
    (set! fd_scb (create_form_scb))
    ; /* show the first form */
    (fl_show_form fd_scb FL_PLACE_CENTERFREE FL_FULLBORDER "form0")
    (fl_do_forms)
    0))

;/* Form definition file generated with fdesign. */

(define fd_scb '())
(define fd_hor '())
(define fd_hor_thin '())
(define fd_hor_nice '())
(define fd_vert '())
(define fd_vert_thin '())
(define fd_vert_nice '())
(define fd_hide '())
(define fd_deactivate '())


(define (create_form_scb)
  (let ((obj '())
	(form '()))
    (set! form (fl_bgn_form FL_NO_BOX  470  230))
    (set! obj (fl_add_box FL_UP_BOX 0 0 470 230 ""))
    (set! obj (fl_add_scrollbar FL_HOR_SCROLLBAR 30 15 230 17 
				"HOR_SCROLLBAR"))
    (set! fd_hor obj)
    (fl_set_object_lsize obj FL_TINY_SIZE)
    (fl_set_object_callback obj noop_cb 0)
    (set! obj (fl_add_scrollbar FL_HOR_THIN_SCROLLBAR 30 60 230 18 
				"HOR_THIN_SCROLLBAR"))
    (set! fd_hor_thin obj)
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_object_lsize obj FL_TINY_SIZE)
    (fl_set_object_callback obj noop_cb 0)
    (fl_set_scrollbar_value obj  0.11)
    (set! obj (fl_add_scrollbar FL_HOR_NICE_SCROLLBAR 30 110 230 18 
				"HOR_NICE_SCROLLBAR"))
    (set! fd_hor_nice obj)
    (fl_set_object_boxtype obj FL_FRAME_BOX)
    (fl_set_object_lsize obj FL_TINY_SIZE)
    (fl_set_object_callback obj noop_cb 0)
    (set! obj (fl_add_scrollbar FL_VERT_SCROLLBAR 300 10 17 185 ""))
    (set! fd_vert obj)
    (fl_set_object_callback obj noop_cb 0)
    (set! obj (fl_add_scrollbar FL_VERT_THIN_SCROLLBAR 338 10 17 185 ""))
    (set! fd_vert_thin obj)
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_object_callback obj noop_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 20 195 80 25 "Hide"))
    (set! fd_hide obj)
    (fl_set_object_callback obj hide_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 100 195 80 25 "Deactivate"))
    (set! fd_deactivate obj)
    (fl_set_object_callback obj deactivate_cb 0)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 200 195 80 25 "Done"))
    (fl_set_object_callback obj done_cb 0)
    (set! obj (fl_add_scrollbar FL_VERT_NICE_SCROLLBAR 370 10 17 185 ""))
    (set! fd_vert_nice obj)
    (fl_set_object_boxtype obj FL_FRAME_BOX)
    (fl_set_object_callback obj noop_cb 0)
    (fl_set_scrollbar_value obj  1)
    (set! obj (fl_add_scrollbar FL_HOR_BASIC_SCROLLBAR 30 155 230 18 
				"HOR_BASIC_SCROLLBAR"))
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_object_lsize obj FL_TINY_SIZE)
    (fl_set_object_callback obj noop_cb 0)
    (fl_set_scrollbar_value obj  0.77)
    (fl_set_scrollbar_size obj  0.20)
    (set! obj (fl_add_scrollbar FL_VERT_BASIC_SCROLLBAR 410 10 17 185 ""))
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_object_callback obj noop_cb 0)
    (fl_set_scrollbar_value obj  0.97)
    (fl_set_scrollbar_size obj  0.20)
    (fl_end_form)
    form))

;/*---------------------------------------*/

(scrollbar)


