;/* This demo shows the use of a setting slider sizes */

(require `forms)

(define (sldsize . args)
  (let ((form `())
	(sl1 `())
	(sl2 `())
	(but `())
	(obj `())) ; JL : now unused 
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 150 300))
    (set! sl1 (fl_add_slider FL_VERT_SLIDER 20 20 40 180 "X"))
    (set! sl2 (fl_add_slider FL_VERT_SLIDER 90 20 40 180 "Y"))
    (set! but (fl_add_button FL_NORMAL_BUTTON 40 250 70 30 "Exit"))
    (fl_end_form)
    ;
    (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "Slider Size")
    (letrec ((loop 
	      (lambda ()
		(fl_set_slider_size sl2 (fl_get_slider_value sl1))
		(fl_set_slider_size sl1 (fl_get_slider_value sl2))
		(if (not (equal? (fl_do_forms) but))
		    (loop)))))
      (loop))
    (fl_hide_form form)
    0))

(sldsize)

