;/*
; * Show the built-in symbols
; *
; * This file is part of xforms package
; * T.C. Zhao and M. Overmars   (1997)
; */

(require `forms)

(define lsymbols 
  (list
   "@>" "@<-" "@9->" "@DnLine" "@8>" "@circle" "@->|" 
   "@>>" "@square" "@4->|" 
   ; "@8->|" 
   "@<->" 
   "@UpArrow" "@9+" "@->" "@<" "@DnArrow" "@+" "@-->" 
   "@line" "@3->" "@UpLine" "@>|" "@2-->" "@4>|" "@8>|" 
   "@=" "@menu" "@8=" "@|>" "@2|>" "@-32|>" "@+32|>" 
   "@-2circle" 
   ;""
   ))

;#define N  (sizeof(symbols)/sizeof(*symbols) - 1)

(define form `())

(define (done_cb ob data)
  (exit 0))

(define r 0)
(define (make_symbols)
  (let* ((buf "")
	 (x0 10)
	 (y0 10)
	 (dx 35)
	 (dy 35)
	 (ty 17)
	 (bn (length lsymbols)) ; JL : changed
	 (n 7)
	 (xsep 15)
	 (ysep 5)
	 (w (+ (* 2 x0) (* n dx) (* (- n 1) xsep)))
	 (h (+ (* 2 y0) (* (modulo bn n)
			   (+ dy ty ysep))))
	 (obj `()))
    (set! form (fl_bgn_form FL_FLAT_BOX w h)) 
    (set! obj (fl_add_button FL_HIDDEN_BUTTON 0 0 w h ""))
    (fl_set_object_callback obj done_cb 0)
    (letrec ((loop
	      (lambda (x y i j s)
		(if (null? s)
		    #t
		    (let* ((p (car s))
			   (buf (string-append " " p))
			   (obj (fl_add_box FL_UP_BOX x y dx dy p)))
		      (fl_set_object_lcol obj FL_BOTTOM_BCOL)
		      (fl_add_box FL_FLAT_BOX x (+ y dy) dx ty buf)
		      (if (= (modulo i n) 0)
			  (loop x0 
				(+ y0 (* j (+ dy ty ysep 1)))
				(+ i 1)
				(+ j 1)
				(cdr s))
			  (loop (+ x dx xsep)
				y
				(+ i 1)
				j
				(cdr s))))))))
      (loop x0 y0 1 1 lsymbols))
    ;
    (fl_end_form)
    (fl_adjust_form_size form)
    ))


(define (symbols . args)
  (fl_initialize args)
  (make_symbols)
  ;
  (fl_show_form form FL_PLACE_FREE FL_FULLBORDER "test")
  ;
  ; (fl_flush) ; JL : added (!) ; JL : and removed again (!!)
  (letrec ((loop
	    (lambda ()
	      (fl_do_forms)
	      (loop))))
    (loop)
    0))

(symbols)
