;/* A demo showing the use of timer objects.
; * note there is only one fl_do_form().
; */

(require `forms)

(define form1 `())
(define form2 `())
(define tim `())
(define tim2 `())

(define TIME 5)

(define (timer1_expired ob q)
  (fl_deactivate_form form1)
  (fl_set_timer tim2 10)
  (fl_show_form form2 FL_PLACE_MOUSE FL_TRANSIENT "Q"))

(define (nothing ob q)
  `())

(define (continue_cb ob q)
  (fl_hide_form form2)
  (fl_activate_form form1)
  (fl_set_timer tim TIME)
  (fl_set_object_callback tim nothing 0))

(define (done_cb ob a)
  (fl_finish)
  (exit 0))

(define (makeforms)
  (let ((obj `()))
    (set! form1 (fl_bgn_form FL_UP_BOX 400 400))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 140 160 120 80 "Push Me"))
    (fl_set_object_callback obj  done_cb  0)
    (set! tim (fl_add_timer FL_VALUE_TIMER 200 40 90 50 "Time Left"))
    (fl_set_object_callback tim  timer1_expired 0)
    (fl_set_object_lcol tim  FL_BLACK)
    (fl_end_form)
    ;
    (set! form2 (fl_bgn_form FL_UP_BOX 320 120))
    (fl_add_box FL_NO_BOX 160 40 0 0 "You were too late")
    (set! obj (fl_add_button FL_NORMAL_BUTTON 100 70 120 30 "Try Again"))
    (fl_set_object_callback obj  continue_cb  0)
    (set! tim2 (fl_add_timer FL_HIDDEN_TIMER 0 0 1 2 ""))
    (fl_set_object_callback tim2  continue_cb  0)
    (fl_end_form)))
    
(define (timer2 . args)
  (fl_initialize args)
  (makeforms)
  (fl_show_form form1 FL_PLACE_CENTER FL_NOBORDER "Timer")
  (fl_set_timer tim TIME)
  (fl_do_forms)
  0)

(timer2)

