;;; signal handler test

(define (handle_int n data)  
  (display "fl-interrupt\n")
  (display "signum : ")
  (display (number->string n))
  (newline)
  )

(define (user-interrupt n data)
  (display "user-interrupt\n")
  (display "signum : ")
  (display (number->string n))
  (newline)
  )

(define (timeout_handler i data)
  (display "\ntimeout : ")
  (display (number->string i))
  (newline)
  (fl_remove_signal_callback 2)
  (exit 1)) ; undefined result otherwise

(define (sigtest . args)
  (fl_initialize args)
  (fl_add_timeout 5000 timeout_handler 0)
  (fl_add_signal_callback 2 handle_int 0)
  (display "Try to raise an interrupt signal\n")
  (fl_do_forms)
  )

(sigtest)
