(require 'forms)

(define win '())
(define form '())
(define obj '())
(define exitobj '())
(define howto_handle 0)

; form_atclose : msg, del window
(define (xev_cb obj i)
  (set! howto_handle i))

(define (handle_event xev v)
  (cond ((= howto_handle 0) ; parameter
	 (fl_print_xevent_name "name : " xev))
	((= howto_handle 1) ; peek
	 (fl_print_xevent_name "name : " (cadr (fl_xpeekevent))))
	((= howto_handle 2) ; next
	 (let ((nev (cadr (fl_xnextevent))))
	   (fl_print_xevent_name "name : " nev)
	   (fl_xputbackevent nev)))
	((= howto_handle 3) ; last
	 (fl_print_xevent_name "name : " (fl_last_event)))
	(else #t)) ; ignore
  0)


(define (xtest . args)
  (fl_initialize "")
  ; initialize window 
  (fl_pref_wingeometry 400 300 400 400)
  (fl_pref_winsize 400 400)
  (set! win (fl_winopen "Window"))
  (fl_winbackground win (fl_get_flcolor FL_COL1)) 
  (fl_set_event_callback handle_event 0)
  ; initialize form
  (set! form (fl_bgn_form FL_UP_BOX 300 300))
  (set! obj (fl_add_button FL_RADIO_BUTTON 45  25 210 30 "Parameter XEvent"))
  (fl_set_object_callback obj xev_cb 0)
  (set! obj (fl_add_button FL_RADIO_BUTTON 45  65 210 30 "Peek XEvent"))
  (fl_set_object_callback obj xev_cb 1)
  (set! obj (fl_add_button FL_RADIO_BUTTON 45 105 210 30 "Next XEvent"))
  (fl_set_object_callback obj xev_cb 2)
  (set! obj (fl_add_button FL_RADIO_BUTTON 45 145 210 30 "Last XEvent"))
  (fl_set_object_callback obj xev_cb 3)
  (set! obj (fl_add_button FL_RADIO_BUTTON 45 185 210 30 "Ignore XEvent"))
  (fl_set_object_callback obj xev_cb 4)
  (set! obj (fl_add_button FL_RADIO_BUTTON 45 225 210 30 "Exit"))
  (set! exitobj obj)
  (fl_end_form)
  (fl_show_form form FL_PLACE_FREE FL_FULLBORDER "Form")
  ; add exit button
  (letrec ((loop (lambda ()
                   (if (not (equal? (fl_do_forms) exitobj))
		       (loop)))))
    (loop))
  (exit 0))

(xtest)
