;/* Multiline labels. */

(require 'forms)

(define form 0)
(define readyobj 0)

(define (create_form_0)
  (let ((obj `()))
    (set! form (fl_bgn_form FL_NO_BOX 400 470))
    (set! obj (fl_add_box FL_UP_BOX 0 0 400 470 ""))
    (fl_set_object_color obj FL_SLATEBLUE FL_COL1)
    (set! obj (fl_add_text FL_NORMAL_TEXT 140 40 120 120 
			   "This is\na multi-line\nlabelT"))
    (fl_set_object_boxtype obj FL_BORDER_BOX)
    (fl_set_object_lalign obj FL_ALIGN_TOP)
    (set! obj (fl_add_text FL_NORMAL_TEXT 140 160 120 120 
			   "This is\na multi-line\nlabelC"))
    (fl_set_object_boxtype obj FL_BORDER_BOX)
    (fl_set_object_color obj FL_PALEGREEN FL_COL1)
    (fl_set_object_lsize obj FL_LARGE_SIZE)
    (fl_set_object_lalign obj FL_ALIGN_CENTER)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 280 400 100 50 
			     "I am sure\nthat I am\nReady"))
    (set! readyobj obj)
    (fl_set_object_lsize obj FL_SMALL_SIZE)
    (set! obj (fl_add_text FL_NORMAL_TEXT 260 160 120 120 
			   "This is\na multi-line\nlabelR"))
    (fl_set_object_boxtype obj FL_BORDER_BOX)
    (fl_set_object_lalign obj FL_ALIGN_RIGHT)
    (set! obj (fl_add_text FL_NORMAL_TEXT 140 280 120 120 
			   "This is\na multi-line\nlabelB"))
    (fl_set_object_boxtype obj FL_BORDER_BOX)
    (fl_set_object_lalign obj FL_ALIGN_BOTTOM)
    (set! obj (fl_add_text FL_NORMAL_TEXT 20 160 120 120 
			   "This is\na multi-line\nlabel"))
    (fl_set_object_boxtype obj FL_BORDER_BOX)
    (fl_end_form)))

;---------------------------------------

(define (multilabel . args)
  (fl_initialize args)
  (create_form_0)
  ;
  (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "Labels")
  ;
  (letrec ((loop
	    (lambda ()
	      (if (not (equal? (fl_do_forms) readyobj))
		  (loop)))))
    (loop)
    (fl_hide_form form)
    0))

(multilabel)

