;/* 
; * Showing the use of non-modal file selector
; *
; * T.C. Zhao and M. Overmars
; */
(require 'forms)

(define ttt '())
(define pm '())
(define bm '())

(define (pmbrowse . args)
  (fl_initialize args)
  (create_form_ttt)
  (fl_show_form ttt FL_PLACE_CENTER FL_TRANSIENT "PixmapBrowser")
  (fl_set_fselector_placement FL_PLACE_FREE)
  (fl_set_fselector_callback load_file 0)
  (fl_show_fselector "Load a Pixmap file" "" "*.x?m" "")
  (fl_do_forms)
  0)

(define (load_file fname data)
  (let* ((ispix #f)
	 (sl (string-length fname))
	 (p (if (>= sl 4)
		(substring fname (- sl 4) sl)
		"")))
    (set! ispix (not (string=? p ".xbm")))
    (if ispix 
	(begin
	  (fl_hide_object bm)
	  (fl_show_object pm)
	  (fl_free_pixmap_pixmap pm)
	  (fl_set_pixmap_file pm fname))
	(begin
	  (fl_hide_object pm)
	  (fl_show_object bm)
	  (fl_set_bitmap_file bm fname)))
    1))

(define (done ob q)
  (fl_finish)
  (exit 0))

(define (reload ob q)
  (fl_set_fselector_placement FL_PLACE_MOUSE)
  (fl_set_fselector_callback load_file 0)
  (fl_show_fselector "Load a Pix/bitMap file"  "" "" ""))

(define (create_form_ttt)
  (let ((obj '()))
    (if (null? ttt)
	(begin
	  (set! ttt (fl_bgn_form FL_NO_BOX 330 320))
	  (set! obj (fl_add_box FL_UP_BOX 0 0 330 320 ""))
	  (set! obj (fl_add_bitmap FL_NORMAL_BITMAP 30 20 270 240 ""))
	  (set! bm obj)
	  (fl_set_object_boxtype obj  FL_FLAT_BOX)
	  (set! obj (fl_add_pixmap FL_NORMAL_PIXMAP 30 20 270 240 ""))
	  (set! pm obj)
	  (fl_set_object_boxtype obj  FL_FLAT_BOX)
	  (set! obj (fl_add_button FL_NORMAL_BUTTON 220 280 90 30 "Done"))
	  (fl_set_object_callback obj  done  0)
	  (set! obj (fl_add_button FL_NORMAL_BUTTON 20 280 90 30 "Load"))
	  (fl_set_object_callback obj  reload  0)
	  (fl_set_object_shortcut obj "L" 1)
	  (fl_end_form)))))

(pmbrowse)

