;/* Demo: complete pop-ups. 
; * test font/cursor change
; * test attaching pup to menu 
; */

(define pup '())
(define done '())
(define pret '())
(define b1 '())
(define b2 '())
(define b3 '())
(define menu '())

(define (pup . args)
;    FL_IOPT aa;
;    unsigned mask = FL_PDVisual;
;
;    aa.vclass = FL_DefaultVisual;
;    fl_set_defaults(mask, &aa);

  (fl_initialize args)
  (create_form_pup)
  ;/* initialize */
  (fl_set_object_posthandler b1 post)
  (fl_set_object_posthandler b2 post)
  (fl_set_object_posthandler b3 post)
  ;
  (fl_show_form pup FL_PLACE_MOUSE FL_TRANSIENT "PupDemo")
  (init_menu)
  ;
  (fl_do_forms)
  (fl_finish)
  (exit 0))

(define subm -1)
(define m -1)
(define ssm 0)
(define n1 -1)
(define n2 -1)

;/* post-handler */
(define (post ob ev mx y key xev)
  (if (= n1 -1)
      (begin
	(set! n1 (fl_defpup (fl_objwin ob) "line1|line2"))
	(fl_setpup_shadow n1 0)
	(fl_setpup_bw n1 0)
	(fl_setpup_pad n1 3 0)
	;
	(set! n2 (fl_defpup (fl_objwin ob) "button1|button2"))
	(fl_setpup_shadow n2 0)
	(fl_setpup_bw n2 -1)
	(fl_setpup_pad n2 3 0)
	))
  (if (= ev FL_ENTER)
      (let* ((fsiz (fl_get_form_position (fl_get_object_form ob)))
	     (obfx (car fsiz))
	     (obfy (cadr fsiz))
	     (osiz (fl_get_object_geometry ob))
	     (obx (car osiz))
	     (oby (cadr osiz))
	     (obh (cadddr osiz)))
	(if (equal? ob b3)
	    (fl_show_oneliner 
	     "button3" 
	     (+ obfx obx)
	     (+ obfy oby obh 5))
	    (begin
	      (fl_setpup_position 
	       (+ obfx obx)
	       (+ obfy oby obh 5))
	      (fl_showpup (if (equal? ob b1) n1 n2)))
	    ))
      (if (not (= ev FL_MOTION)) ; else
	  (if (equal? ob b3)
	      (fl_hide_oneliner)
	      (fl_hidepup (if (equal? ob b1) n1 n2)))))
  0)


(define (show_return_val i)
  (let ((buf ""))
    (if (>= i 0)
      (set! buf 
	    (string-append 
	     "Returned "
	     (number->string i)
	     "("
	     (fl_getpup_text m i)
	     ")"))
      (set! buf
	    (string-append 
	     "Returned "
	     (number->string i))))
    (fl_set_object_label pret buf)))

(define (ssm_cb a)
  (show_return_val a)
  a)

(define n 0)
(define XC_hand2 60)             ; JL : from cursorfont.h
(define XC_sb_right_arrow 112)   ; JL : from cursorfont.h

(define (do_pup ob q)
  (if (= subm -1)
      (begin
	(set! ssm  (fl_newpup (fl_objwin ob)))
	(set! subm (fl_newpup (fl_objwin ob)))
	(set! m    (fl_newpup (fl_objwin ob)))
	;
	;/* (fl_addtopup ssm "SubSubM%F%t" ssm_cb)
	(fl_addtopup ssm "SSMItem20%x20%R1")
	(fl_addtopup ssm "SSMItem21%x21%r1")
	(fl_addtopup ssm "SSMItem22%x22%r1%l")
	(fl_addtopup ssm "SSMitem30%x30%R2")
	(fl_addtopup ssm "SSMItem31%x31%r2")
	(fl_addtopup ssm "SSMItem32%x32%r2")
	;
	;/* (fl_addtopup subm "SubMenu%t") */
	(fl_addtopup subm "SMItemA\tAlt-A%x10%h" "#a")
	(fl_addtopup subm "SMItemB\tAlt-B%x11%h" "#b")
	(fl_addtopup subm "SMItemC\tAlt-C%x12%h" "#c")
	(fl_addtopup subm "SMItemD\tAlt-F5%x13%h%m" "#&5" ssm)
	(fl_addtopup subm "SMItemE\tAlt-E%x14" "#E")
	;
	(fl_setpup_mode subm  14  FL_PUP_GREY)
	;
	(fl_addtopup m "PopUP%t")
	(fl_addtopup m "MenuItem1%h" "1#1")
	;
	(fl_addtopup m "MenuItem2%h" "2#2")
	(fl_setpup_submenu m  2  subm)
	(fl_addtopup m "MenuItem3%h" "3#3")
	(fl_addtopup m "MenuItem4%h" "4#4")
   ))


  (if (>= (fl_get_button_numb ob) FL_SHORTCUT)
      (let* ((fsiz (fl_get_form_position (fl_get_object_form ob)))
	     (obfx (car fsiz))
	     (obfy (cadr fsiz))
	     (osiz (fl_get_object_geometry ob))
	     (obx (car osiz))
	     (oby (cadr osiz))
	     (obh (cadddr osiz)))
      (fl_setpup_position (+ obfx obx)
			  (+ obfy oby obh))))

  (show_return_val (fl_dopup m))
  ;/* test if changing size/style ok */
  (set! n (abs (- n 1)))
  (fl_setpup_fontsize (if (= n FL_TRUE) 14 12))
  (fl_setpup_fontstyle (if (= n FL_TRUE) FL_TIMES_STYLE FL_BOLDITALIC_STYLE))
  (fl_setpup_cursor m  (if (= n FL_TRUE) XC_hand2 XC_sb_right_arrow)))


(define (init_menu)
  (let ((mm 0)
	(smm 0))
    (set! mm (fl_newpup (fl_default_win)))
    (fl_setpup_bw mm  -2)
    (fl_setpup_shadow mm  0)
    (set! smm (fl_newpup (fl_default_win))) ; JL was : 0
    (fl_setpup_shadow smm  0)
    ;
    (fl_addtopup mm "MenuItem1|MenuItem2%m|MenuItem3" smm)
    (fl_addtopup smm "SubItem1%x11|SubItem2%x12|SubItem3%x13")
    ;
    ; /* attach pup to menu */
    (fl_set_menu_popup menu  mm)))

(define (do_menu ob data)
  (let ((buf ""))
    (if (>= (fl_get_menu ob) 0)
	(set! buf
	      (string-append
	       (number->string (fl_get_menu ob))
	       " ("
	       (fl_get_menu_text ob)
	       ")"))
	(set! buf
	      (string-append
	       (number->string (fl_get_menu ob)))))
    (fl_set_object_label pret  buf)))

(define (done_cb ob data)
  (exit 0))

(define (create_form_pup)
  (if (not (null? pup))
      (let ((obj '()))
	(set! pup (fl_bgn_form FL_UP_BOX 260 210))
	(set! obj (fl_add_button FL_NORMAL_BUTTON 150 150 90 35 "Done"))
	(set! done obj)
	(fl_set_object_callback obj done_cb  0)
	(set! obj (fl_add_button FL_MENU_BUTTON 30 90 100 30 "PopUp"))
	(fl_set_button_shortcut obj "Pp#p" 1)
	(fl_set_object_callback obj  do_pup  0)
	(set! obj (fl_add_menu FL_PULLDOWN_MENU 160 95 60 25 "Menu"))
	(set! menu obj)
	(fl_set_object_callback obj  do_menu  0)
	(set! obj (fl_add_text FL_NORMAL_TEXT 20 60 220 30 ""))
	(set! pret obj)
	(fl_set_object_lalign obj FL_ALIGN_CENTER)
	(set! b1 (fl_add_button FL_NORMAL_BUTTON  20  10  60  30 "Button1"))
	(set! b2 (fl_add_button FL_NORMAL_BUTTON  90  10  60  30 "Button2"))
	(set! b3 (fl_add_button FL_NORMAL_BUTTON  160  10  60  30 "Button3"))
	(fl_end_form))))

(pup)
