;/* A demo that shows the use of push buttons.  */

(require 'forms)

(define form `())
(define abox `())

(define (substitute l i ielt)
  (if (or (< i 0) (null? l)) 
      l
      (if (= i 0)
	  (cons ielt (cdr l))
	  (cons (car l)
		(substitute (cdr l) (- i 1) ielt)))))

(define (push_cb ob n)
  (if (= (fl_get_button ob) 1)
      (fl_show_object (list-ref abox n))
      (fl_hide_object (list-ref abox n))))

(define (makeform)
  (let ((obj `())
	(l `(0 1 2 3 4 5 6 7)))
    (set! form (fl_bgn_form FL_UP_BOX 400 400))
    (map (lambda (i)
	   (set! obj (fl_add_button 
		      FL_PUSH_BUTTON 40 (- 310 (* 40 i)) 80 30 ""))
	   (fl_set_object_color obj (+ FL_BLACK i 1) (+ FL_BLACK i 1))
	   (fl_set_object_callback obj push_cb i)
	   (set! obj (fl_add_box FL_DOWN_BOX (+ 150 (* 30 i)) 40 25 320 ""))
	   (set! abox (append abox (list obj)))
	   (fl_set_object_color obj (+ FL_BLACK i 1) (+ FL_BLACK i 1))
	   (fl_hide_object obj))
	 l)
    (fl_add_button FL_NORMAL_BUTTON 40 350 80 30 "Exit")
    (fl_end_form)))

(define (pushbutton . args)
  (fl_initialize args)
  (makeform)
  ;
  (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "Push Buttons");
  ;/* fl_do_forms will return only when Exit is pressed */
  (fl_do_forms)
  (fl_finish) ; JL : added
  0)

(pushbutton)