;/* This demo shows the use of a slider that is not active */

(require `forms)

(define (sldinactive . args)
  (let ((form `())
	(sl1 `())
	(sl2 `())
	(but `())
	(obj `()))
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 150 300))
    (set! sl1 (fl_add_slider FL_VERT_SLIDER 20 20 40 180 "X"))
    (set! sl2 (fl_add_slider FL_VERT_SLIDER 90 20 40 180 "1-X"))
    (fl_deactivate_object sl2)
    (set! but (fl_add_button FL_NORMAL_BUTTON 40 250 70 30 "Exit"))
    (fl_end_form)
    ;
    (fl_show_form form FL_PLACE_CENTER FL_NOBORDER "Inactive Slider")
    ;
    (letrec ((loop 
	      (lambda ()
		(set! obj (fl_do_forms))
		(fl_set_slider_value sl2 (- 1.0 (fl_get_slider_value sl1)))
		(if (not (equal? obj but))
		    (loop)))))
      (loop)
      (fl_hide_form form)
      0)))

(sldinactive)


