(require `forms)
(require `struct) ; SLIB

;/**** Forms and Objects ****/

(define-record s_fd_form0
  (form0
   vdata
   ldata
   text))

(define fd_form0 (make-s_fd_form0 0 0 0 0))

;/* callbacks for form form0 */
(define (exit_cb ob data)
  (exit 0))

(define (input_cb ob data)
  (let* ((s (fl_get_input ob))
	 (w (fl_get_string_width (fl_get_object_lstyle ob)
				 (fl_get_object_lsize ob)
				 s
				 (string-length s)))
	 (hc (fl_get_string_height (fl_get_object_lstyle ob)
				   (fl_get_object_lsize ob)
				   s 
				   (string-length s)))
	 (h (car hc))
	 (buf ""))
    (set! buf (string-append "w=" (number->string w) 
			     " h=" (number->string h)))
    (fl_set_object_label (s_fd_form0->text fd_form0) buf)))
    


(define (strsize . args)
  (fl_initialize args)
  (set! fd_form0 (create_form_form0))
  ;/* fill-in form initialization code */
  ;
  ;/* show the first form */
  (fl_show_form (s_fd_form0->form0 fd_form0) 
		FL_PLACE_CENTER FL_FULLBORDER "form0")
  ;
  (fl_do_forms)
  0)


;/* Form definition file generated with fdesign. */

(define (create_form_form0)
  (let ((obj `())
	(fdui (make-s_fd_form0 0 0 0 0)))
    ;
    (set-s_fd_form0-form0! fdui (fl_bgn_form FL_NO_BOX  311  181))
    (set! obj (fl_add_box FL_UP_BOX 0 0 311 181 ""))
    (set! obj (fl_add_button FL_NORMAL_BUTTON 220 130 80 30 "Done"))
    (fl_set_object_callback obj exit_cb 0)
    (set! obj (fl_add_input FL_NORMAL_INPUT 20 30 280 30 ""))
    (fl_set_object_callback obj input_cb 0)
    (set! obj (fl_add_text FL_NORMAL_TEXT 60 90 130 30 "Text"))
    (set-s_fd_form0-text! fdui obj)
    (fl_set_object_lalign obj (logior FL_ALIGN_LEFT FL_ALIGN_INSIDE))
    (fl_end_form)
    fdui))

;/*---------------------------------------*/

(strsize)