(require `forms)
; JL : Bug - fl_get_xyplot ? / fl_set_xyplot_interpolate
; 1. move 8th (!) point to X=7.9... , Y=0.0...
; 2. press Interpolate button
; 3. compare result with original demo 
; 4. My Error !
; JL : BUG fixed

;/**** Forms and Objects ****/

;(define xypui '())
(define xypui_axypform '())
(define xypui_xyplot '())
(define xypui_status '())

;/* callbacks for form axypform */
(define (xyplot_cb ob data)
  (let* ((xyp (fl_get_xyplot ob))
	 (x (car xyp))
	 (y (cadr xyp))
	 (i (caddr xyp)))
    (if (not (< i 0))
	(fl_set_object_label xypui_status 
			     (string-append 
			      "X="
			      (substring 
			       (string-append (number->string x) "    ")
			       0 4)
			      " Y="
			      (substring 
			       (string-append (number->string y) "    ")
			       0 4)))
	)))

(define (alwaysreturn_cb ob data)
  (fl_set_xyplot_return xypui_xyplot (fl_get_button ob)))

(define (interpolate_cb ob data)
  (fl_set_xyplot_interpolate xypui_xyplot 0 
			     (if (= (fl_get_button ob) FL_TRUE)
				 3 0)
			     0.2))

(define (inspect_cb ob data)
  (fl_set_xyplot_inspect xypui_xyplot (fl_get_button ob)))

(define (notic_cb ob data)
  (let ((notic (fl_get_button ob)))
    (if (= notic FL_TRUE)
	(begin
	  (fl_set_xyplot_xtics xypui_xyplot -1 -1)
	  (fl_set_xyplot_ytics xypui_xyplot -1 -1)
	  )
	(begin
	  (fl_set_xyplot_xtics xypui_xyplot 0 0)
	  (fl_set_xyplot_ytics xypui_xyplot 0 0)
	  )
	)))


(define (xyplotactive . args)
  (let ((x (list 0 1 2 3 4 5 6 7 8 9 10))
	(y (list 0 1 2 3 4 5 6 7 8 9 10))
	(i 0))
    (fl_initialize args)
    (create_form_axypform)
    ; /* fill-in form initialization code */
    (fl_set_object_dblbuffer xypui_status 1)
    (fl_set_xyplot_data xypui_xyplot x y 11 "" "" "")
    (fl_set_xyplot_linewidth xypui_xyplot 0 2)
    (fl_set_xyplot_xgrid xypui_xyplot FL_GRID_MINOR)
    ;
    ; /* show the first form */
    (fl_show_form xypui_axypform FL_PLACE_MOUSE FL_TRANSIENT "axypform")
    (fl_do_forms)
    (fl_finish)
    0))

(define (create_form_axypform)
  (let ((obj '()))
    (set! xypui_axypform (fl_bgn_form FL_NO_BOX  431  301))
    (set! obj (fl_add_box FL_UP_BOX 0 0 431 301 ""))
    (set! obj (fl_add_xyplot FL_ACTIVE_XYPLOT 20 50 285 235 ""))
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (fl_set_object_color obj FL_BLACK FL_GREEN)
    (fl_set_object_lalign obj (logior FL_ALIGN_BOTTOM FL_ALIGN_INSIDE))
    (fl_set_object_callback obj xyplot_cb 0)
    (set! xypui_xyplot obj)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 40 80 25 "AlwaysReturn"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj alwaysreturn_cb 0)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 65 80 25 "Interpolate"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj interpolate_cb 0)
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 90 85 25 "InspectOnly"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj inspect_cb 0)
    (set! obj (fl_add_box FL_BORDER_BOX 45 15 170 25 ""))
    (fl_set_object_boxtype obj FL_DOWN_BOX)
    (set! xypui_status obj)
    (set! obj (fl_add_button FL_NORMAL_BUTTON 325 250 90 30 "Done"))
    (set! obj (fl_add_checkbutton FL_PUSH_BUTTON 315 120 85 25 "NoTics"))
    (fl_set_object_color obj FL_COL1 FL_BLUE)
    (fl_set_object_callback obj notic_cb 0)
    (fl_end_form)
    #t))

;/*---------------------------------------*/
(xyplotactive)
