;;; turtle color test

(require 'turtle-graphics)
(require 'forms)


(define (colorbox w c)
  (set-color! c)
  (turn-to! 0)
  (draw w)
  (turn-left 90)
  (draw w)
  (turn-left 90)
  (draw w)
  (turn-left 90)
  (draw w)
  )

(define (grcolors)
  (graphics-mode!)
  (display "testing colors")
  (goto-nw!)
  (let ((w 50)
	(sx 20)
	(sy 20))
    (letrec ((loop 
	      (lambda (i x y)
		(if (> i (max-color))
		    #t
		    (begin
		      (turn-to! 0)
		      (move-to! x y)
		      (colorbox w i)
		      (if (= (modulo i 4) 3)
			  (loop (+ i 1) sx (+ y (* w 1.5)))
			  (loop (+ i 1) (+ x (* w 1.5)) y))
		      )))))
      (loop 0 sx sy))))

(grcolors)
