;;; probability slider

(require 'forms)

(define (slidprb pstring . args)
  (let ((form '())
	(obj '())
	(slid_obj '())
	(objtext "")
	(button '())
	(prob 0.5))
    ;
    (fl_initialize args)
    (set! form (fl_bgn_form FL_UP_BOX 300 330))
    (set! obj (fl_add_labelframe FL_ENGRAVED_FRAME 15 15 270 55 
				 "Probability slider"))
    (fl_set_object_lsize obj FL_MEDIUM_SIZE)
    (set! obj (fl_add_text FL_NORMAL_TEXT 30 30 240 30 
			   pstring))
    (fl_set_object_align obj FL_ALIGN_CENTER)
    (set! slid_obj (fl_add_slider FL_VERT_FILL_SLIDER 100 90 109 109 ""))
    (fl_set_object_boxtype slid_obj FL_EMBOSSED_BOX)
    (fl_set_slider_bounds slid_obj 1.0 0.0)
    (fl_set_slider_value slid_obj prob)
    (fl_set_object_color slid_obj FL_WHITE FL_DIAL_COL2)
    (fl_set_object_align slid_obj FL_ALIGN_CENTER)
    (set! objtext (fl_add_box FL_FRAME_BOX 15 240 270 30 
			      (string-append "Probability : "
					     (number->string prob)))) 
    (set! button (fl_add_button FL_NORMAL_BUTTON 45 280 210 35 
				"Done"))
    (fl_set_object_lsize button FL_MEDIUM_SIZE)
    (fl_end_form)
    (fl_show_form form FL_PLACE_MOUSE FL_TRANSIENT 
		  "Probability assessment")

    (letrec ((loop 
              (lambda ()
		(fl_set_object_label 
		 objtext 
		 (substring (string-append 
			     "Probability : " 
			     (number->string (fl_get_slider_value slid_obj))
			     (make-string 8 #\space)) 0 20))
                (if (not (equal? (fl_do_forms) button))
                    (loop)
		    (fl_get_slider_value slid_obj)))))
      (set! prob (loop))
      (fl_hide_form form)
      prob)
    ))

(display (slidprb
	  (string-append "Select probability by changing the size\n"
			 "of the slider's black sector.")))

