/*
**
** SForms : Interface to the XForms library for SCM
**
** This file is part of the SForms extension for SCM.
** (for XForms version 0.88 & SCM version 5b2 / 5c3)
**
** Author : Johannes Leveling
** eMail  : Johannes.Leveling@Informatik.Uni-Oldenburg.De
** Copyright (C) 1997, 1998 Free Software Foundation, Inc.
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this software; see the file COPYING.  If not, write to
** the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

/*
** sforms.c
** nov 26 1998
*/
/* */
#include "s_basic.c"
#include "s_bitmap.c"
#include "s_box.c"
#include "s_browser.c"
#include "s_button.c"
#include "s_callb.c"
#include "s_canvas.c"
#include "s_chart.c"
#include "s_choice.c"
#include "s_clipbd.c"
#include "s_clock.c"
#include "s_counter.c"
#include "s_cursor.c"
#include "s_dial.c"
#include "s_event.c"
#include "s_extra.c"
#include "s_filesys.c"
#include "s_flps.c"
#include "s_folder.c"
#include "s_forms.c"
#include "s_frame.c"
#include "s_free.c"
#include "s_goodies.c"
#include "s_input.c"
#include "s_menu.c"
#include "s_menubar.c"
#include "s_popup.c"
#include "s_positioner.c"
#include "s_scrollbar.c"
#include "s_slider.c"
#include "s_text.c"
#include "s_timer.c"
#include "s_xbasic.c"
#include "s_xyplot.c"


/*
** EOF
*/






